import 'dart:io';

import 'package:http/http.dart';
import 'dart:convert';

import '../Annotation.dart';

abstract class RapidFireHttp {
  HttpRF requests();
}

class Api {
  void sync(
    Object model, {
    bool valid,
    String processAlertText,
  }) {
//display tesxt
  }

  final client = new HttpClient();

  var params = {
    "ApiPacket": {
      "Packet": {
        "IncludeChild": false,
        "ModelName": "Student",
        "OrderBy": "",
        "Select": "select * from student inner join UserSchool  ON  student.SchoolId=UserSchool.SchoolId",
        "Where": " UserSchool.UserId = 23 and student.SchoolId=16"
        // and student.SchoolId=16
      }
    },
    "Command": "GetData",
    "PageNo": 1,
    "PageSize": 20,
    "TableName": "Student",
    "TotalRecord": 1,
    "UserId": 23
  };
  var param = {'title': ''};
  dynamic fetch(
    Object model, {
    bool valid,
    String processAlertText,
    int pageNo = 1,
    dynamic onComplete,
  }) async {
    params['PageNo'] = pageNo;

    var response =
        await post("http://egeapi.scibd.info/api/Fetch/GetPacket", body: json.encode(params), headers: {
      HttpHeaders.contentTypeHeader: "application/json",
    });

    if (response.statusCode == 200) {
      var jsonMap = jsonDecode(response.body);
      //     List packetList = jsonMap['ApiPacket']['PacketList'] as List;
//      List<dynamic> records = List();
//      for (int i = 0; i < packetList.length; i++) {
//        var rec =
//            Mapper().jsonToModel(Dynamic(model).newClass(), packetList[i]);
//        records.add(rec);
//      }
      //onComplete(jsonMap['ApiPacket']['PacketList']);
      return jsonMap['ApiPacket']['PacketList'];
    } else {
      throw Exception('Failed to load album');
    }
  }

//  ApiResponse abc(dynamic data) {
//    ApiResponse response = ApiResponse();
//
//    response.PageNo = data['PageNo'];
//    var packet = data['ApiPacket']['Packet'];
//    List packetList = data['ApiPacket']['PacketList'] as List;
//
//    response.Success = data['Success']; //??
//    response.Message = data['Message']; //??
//    response.ServerRecordId = data['ServerRecordId']; //
//    response.RecordId = data['RecordId']; //
//    response.TotalRecord = data['TotalRecord']; //
//    response.PageNo = data['PageNo']; //
//    response.PageSize = data['PageSize']; //
//    response.ApiPacket = data['ApiPacket'];
//    response.Status = data['Status']; //
//  }
}

class SyncRF {
  final model;
  final valid;
  final handeler;
  final onComplete;
  final processAlert;

  SyncRF(this.model, this.handeler, {this.onComplete, this.valid, this.processAlert});
}

class FetchRF {
  final model;
  final valid;
  final handeler;
  final onComplete;
  final processAlert;

  FetchRF(this.model, this.handeler, {this.onComplete, this.valid, this.processAlert});
}

class HttpRF {
  final List<SyncRF> sync;
  final List<FetchRF> fetch;

  HttpRF({this.sync, this.fetch});
}

class RFHttpImpl extends RapidFireHttp {
  @override
  HttpRF requests() {
    return HttpRF(sync: [
      SyncRF(null, null),
      SyncRF(null, null),
    ], fetch: [
      FetchRF(null, null),
      FetchRF(null, null),
    ]);
  }

  void test() {
    Api api;

//    api.sync(Student(), valid: checkUnSyncedDataFor([SampleJson()]));
//
//    api.fetch(Student(),
//        onComplete: (model) => {
//              //
//            });
  }

  bool checkUnSyncedDataFor(List list) {}
}

class apiSynctest {
  // IapiSomename
  // void validate(Validators validators){
  //    validators.register('*', someValidator())
  // }

  // void handle(Handlers handlers){
  //    handlers.register('Student', ()=>{
  //
  //    })
  // }

  // void onSyncComplete(Handlers handlers){
  //    handlers.register('Student', ()=>{
  //
  //    })
  // }

}

//@Model
class ApiRequest {
  int UserId;
  String TableName;
  String Command;
  int TotalRecord;
  int PageNo;
  int PageSize;
  ApiPacket1 ApiPacket = new ApiPacket1();
}

//@Model
class ApiResponse {
  bool Success;
  String Message;
  int ServerRecordId;
  Object RecordId;
  int TotalRecord;
  int PageNo;
  int PageSize;
  ApiPacket1 ApiPacket = new ApiPacket1();
  int Status;
}

//@Model
class ApiPacket1<T> {
  T Packet;
  List<T> PacketList;

  T getPacket() {
    return Packet;
  }

  void setPacket(T packet) {
    Packet = packet;
  }

  List<T> getPacketList() {
    return PacketList;
  }

  void setPacketList(List<T> packetList) {
    PacketList = packetList;
  }
}